\documentclass{report}
\usepackage[T1]{fontenc}
\usepackage[utf8]{inputenc}
\usepackage[english]{babel}
\usepackage[a4paper, top=2.5cm, bottom=2.5cm, left=2.5cm, right=2.5cm]{geometry}
\usepackage{fancyhdr}
\pagestyle{fancy}
\lhead{\textbf{Machine Learning \& Artifical Intelligence}}
\rhead{Homework 02}
\lfoot{Enrico Franco}
\rfoot{Politecnico di Torino}
\usepackage{graphicx}					% Images
\usepackage{subcaption}
\usepackage{booktabs}					% Tables
\usepackage{multirow}
\usepackage[hidelinks]{hyperref}		% Links
\author{Enrico Franco}
\title{Machine Learning \& Artifical Intelligence \\ Homework 02}

\begin{document}
\section*{Data preparation}
The \emph{iris} dataset is loaded, normalized by subtracting its mean and dividing for its standard deviation for each dimension, permutated and split in tranining, validation and test subsets with proportion 5 : 2 : 3.

\section*{Linear kernel}
Different SVM models are built using different values of $C$, which represents the penalty assigned to errors. A large $C$ value means penalize a lot, i.e., the SVM will try to find a hyperplane and margin so that there are few very points within the margin. A lower $C$ gives higher error on the training set, but finds a larger margin that might be more robust.

Boundaries between classes change, accepting few or more ``wrong'' samples in each class, as shown in figure~\ref{img:lin_kernel_boundaries}. The best value of $C$, i.e., the one performing better on the validation set, is used to build a new model, then tested on the test set.

Table~\ref{tab:lin_kernel_accuracy} and figure~\ref{img:lin_kernel_accuracy} show the validation results. On this run, $C = 10^{1}$ has been chosen to test the test set, with an accuracy of 72.00\%.

\begin{table}[hbtp]
\centering
\begin{tabular}{cccccccc}
\toprule
$C$ & $10^{-3}$ & $10^{-2}$ & $10^{-1}$ & $10^{0}$ & $10^{1}$ & $10^{2}$ & $10^{3}$ \\
\midrule
\textup{Validation accuracy} & 40.00\% & 66.67\% & 80.00\% & 80.00\% & 83.33\% & 80.00\% & 80.00\% \\
\bottomrule
\end{tabular}
\caption{Linear kernel -- Accuracy}
\label{tab:lin_kernel_accuracy}
\end{table}

\begin{figure}[hbtp]
\centering
\includegraphics[scale=0.7]{accuracy_linear_kernel.jpg}
\caption{Linear kernel -- Accuracy}
\label{img:lin_kernel_accuracy}
\end{figure}

\section*{RBF kernel}
A RBF kernel may perform better because it can produce non-linear boundaries. The general considerations about the $C$ parameter are still valid. RBF kernel introduces a parameter $\gamma$, which in this first case has not been set, i.e., automatically chosen by the framework.

In the RBF kernel, $\gamma$ adjusts the similarity measure, i.e., how similar two points must be to be considered ``similar''. If we think of the RBF kernel as an hypersphere around each point, whose density is described by a Gaussian function. The value that the kernel generates for a point is the density of the hypersphere around that point. $\gamma$ controls the standard deviation of the Gaussian function. Larger values mean smaller standard deviation around each point.

Accuracy results are reported in table~\ref{tab:rbf_kernel_accuracy} and figure~\ref{img:rbf_kernel_accuracy}, while boundaries are reported in figure~\ref{img:rbf_kernel_boundaries}.

On this run, $C = 10^{0}$ has been chosen to test the test set, with an accuracy of 70.00\%.

\begin{table}[hbtp]
\centering
\begin{tabular}{cccccccc}
\toprule
$C$ & $10^{-3}$ & $10^{-2}$ & $10^{-1}$ & $10^{0}$ & $10^{1}$ & $10^{2}$ & $10^{3}$ \\
\midrule
\textup{Validation accuracy} & 40.00\% & 40.00\% & 66.67\% & 80.00\% & 80.00\% & 80.00\% & 63.33\% \\
\bottomrule
\end{tabular}
\caption{RBF kernel -- Accuracy}
\label{tab:rbf_kernel_accuracy}
\end{table}

\begin{figure}
\centering
\includegraphics[scale=0.7]{accuracy_rbf_kernel.jpg}
\caption{RBF kernel -- Accuracy}
\label{img:rbf_kernel_accuracy}
\end{figure}

\begin{figure}[hbtp]
\centering
\includegraphics[angle=270, scale=0.75]{boundaries_linear_kernel.jpg}
\caption{Linear kernel -- Boundaries}
\label{img:lin_kernel_boundaries}
\end{figure}

\begin{figure}[hbtp]
\centering
\includegraphics[angle=270, scale=0.75]{boundaries_rbf_kernel.jpg}
\caption{RBF kernel -- Boundaries}
\label{img:rbf_kernel_boundaries}
\end{figure}

\subsection*{Grid search}
Grid search is a technique used to tune the model and find the best couple $\gamma, C$.

Results are shown in table~\ref{tab:rbf_kernel_accuracy_grid}. On this run, $\gamma = 10^{-1}$ and $C = 10^{2}$ have been chosen to test the test set, with an accuracy of 74.00\%. Boundaries generated by this model are shown in figure~\ref{img:rbf_kernel_c_gamma}.

\begin{table}[hbtp]
\centering
\begin{tabular}{cc|ccccc}
\toprule
& & \multicolumn{5}{c}{$C$} \\
& & $10^{-2}$ & $10^{-1}$ & $10^{0}$ & $10^{1}$ & $10^{2}$ \\
\midrule
\multirow{6}{*}{$\gamma$}	& $10^{-3}$	& 40.00\% & 40.00\% & 40.00\% & 70.00\% & 80.00\% \\
						& $10^{-2}$	& 40.00\% & 40.00\% & 70.00\% & 80.00\% & 80.00\% \\
						& $10^{-1}$	& 40.00\% & 66.67\% & 80.00\% & 80.00\% & 83.33\% \\
						& $10^{0}$	& 40.00\% & 66.67\% & 80.00\% & 80.00\% & 73.33\% \\
						& $10^{1}$	& 40.00\% & 40.00\% & 70.00\% & 73.33\% & 73.33\% \\
						& $10^{2}$	& 40.00\% & 40.00\% & 46.67\% & 46.67\% & 46.67\% \\
\bottomrule
\end{tabular}
\caption{RBF kernel -- Accuracy}
\label{tab:rbf_kernel_accuracy_grid}
\end{table}

\begin{figure}[hbtp]
\centering
\includegraphics[scale=0.75]{rbf_kernel_c_gamma.jpg}
\caption{RBF kernel -- $C$, $\gamma$ selected using grid search}
\label{img:rbf_kernel_c_gamma}
\end{figure}

\section*{K-Fold}
K-fold is used to average the results. Training and validation subsets are merged in a single training set, which will be split in 5 folds. The advantage of this method is that all observations are used for both training and validation, and each observation is used for validation exactly once. It generally results in a less biased or less optimistic estimate of the model skill than other methods, e.g., simple train/test split.

Also in this case, grid search is performed to find the best couple $\gamma, C$. Results are shown in table~\ref{tab:rbf_kernel_accuracy_kfold}.

On this run, $\gamma = 10^{-2}$ and $C = 10^{2}$ have been chosen to test the test set, with an accuracy of 72.00\%. Boundaries generated by this model are shown in figure~\ref{img:rbf_kernel_c_gamma_kfold}.

\begin{table}[hbtp]
\centering
\begin{tabular}{cc|ccccc}
\toprule
& & \multicolumn{5}{c}{$C$} \\
& & $10^{-2}$ & $10^{-1}$ & $10^{0}$ & $10^{1}$ & $10^{2}$ \\
\midrule
\multirow{6}{*}{$\gamma$}	& $10^{-3}$	& 37.14\% & 37.14\% & 37.14\% & 75.24\% & 80.00\% \\
						& $10^{-2}$	& 37.14\% & 37.14\% & 76.19\% & 80.00\% & 80.95\% \\
						& $10^{-1}$	& 37.14\% & 69.52\% & 79.05\% & 80.95\% & 80.00\% \\
						& $10^{0}$	& 37.14\% & 71.43\% & 80.95\% & 77.14\% & 72.38\% \\
						& $10^{1}$	& 37.14\% & 37.14\% & 68.57\% & 67.62\% & 71.43\% \\
						& $10^{2}$	& 37.14\% & 37.14\% & 49.52\% & 49.52\% & 49.52\% \\
\bottomrule
\end{tabular}
\caption{RBF kernel -- Accuracy using K-fold}
\label{tab:rbf_kernel_accuracy_kfold}
\end{table}

\begin{figure}[hbtp]
\centering
\includegraphics[scale=0.75]{rbf_kernel_c_gamma_kfold.jpg}
\caption{RBF kernel -- $C$, $\gamma$ selected using grid search after K-fold}
\label{img:rbf_kernel_c_gamma_kfold}
\end{figure}
\end{document}
